#ifndef __CD_BI__
#define __CD_BI__

' see copyright notice at the file iup.txt

#include once "iup.bi"

#inclib "cd"
#inclib "freetype"
#inclib "z"

#define CD_NAME "CD - Canvas Draw"
#define CD_DESCRIPTION "A 2D Graphics Library"
#define CD_COPYRIGHT "Copyright (C) 1994-2012 Tecgraf, PUC-Rio."
#define CD_VERSION "5.5"              /' bug fixes are reported only by cdVersion functions '/
#define CD_VERSION_NUMBER 505000
#define CD_VERSION_DATE "2012/01/04"  /' does not include bug fix releases '/

type _cdContext as any : type cdContext as _cdContext
type _cdCanvas  as any : type cdCanvas  as _cdCanvas
type _cdStater  as any : type cdState   as _cdState
type _cdImage   as any : type cdImage   as _cdImage

/' client images using bitmap structure '/
type _cdBitmap
  as integer w
  as integer h
  as integer type
  as any ptr data
end type
type cdBitmap as _cdBitmap

type cdSizeCB   as function cdecl (canvas as cdCanvas ptr, w as integer, h as integer, w_mm as double, h_mm as double) as integer
type cdCallback as function cdecl (canvas as cdCanvas ptr, ...) as integer

extern "c"

/' library '/
_DF_ cdVersion() as zstring ptr
_DF_ cdVersionDate() as zstring ptr
_DF_ cdVersionNumber() as integer

/' canvas init '/
_DF_ cdCreateCanvas(context as cdContext ptr, data as any ptr) as cdCanvas ptr
_DF_ cdCreateCanvasf(context as cdContext ptr, format as const zstring ptr, ...) as cdCanvas ptr
_DS_ cdKillCanvas(canvas as cdCanvas ptr)

_DF_ cdCanvasGetContext(canvas as cdCanvas ptr) as cdContext ptr
_DF_ cdCanvasActivate(canvas as cdCanvas ptr) as integer
_DS_ cdCanvasDeactivate(canvas as cdCanvas ptr)
_DF_ cdUseContextPlus(use as integer) as integer
_DS_ cdInitContextPlus()   /' need an external library '/
_DS_ cdFinishContextPlus()   /' need an external library '/

/' context '/
_DF_ cdContextRegisterCallback(context as cdContext ptr, cb as integer, func as cdCallback) as integer
_DF_ cdContextCaps(context as cdContext ptr) as ulong
_DF_ cdContextIsPlus(context as cdContext ptr) as integer
_DF_ cdContextType(context as cdContext ptr) as integer

/' control '/
_DF_ cdCanvasSimulate(canvas as cdCanvas ptr, mode as integer) as integer
_DS_ cdCanvasFlush(canvas as cdCanvas ptr)
_DS_ cdCanvasClear(canvas as cdCanvas ptr)
_DF_ cdCanvasSaveState(canvas as cdCanvas ptr) as cdState ptr
_DS_ cdCanvasRestoreState(canvas as cdCanvas ptr, state as cdState ptr)
_DS_ cdReleaseState(state as cdState ptr)
_DS_ cdCanvasSetAttribute(canvas as cdCanvas ptr, name as const zstring ptr, data as zstring ptr)
_DS_ cdCanvasSetfAttribute(canvas as cdCanvas ptr, name as const zstring ptr, format as const zstring ptr, ...)
_DF_ cdCanvasGetAttribute(canvas as cdCanvas ptr, name as const zstring ptr) as zstring ptr

/' interpretation '/
_DF_ cdCanvasPlay(canvas as cdCanvas ptr, context as cdContext ptr, xmin as integer,  xmax as integer, ymin as integer, ymax as integer, data as any ptr) as integer

/' coordinate transformation '/
_DS_ cdCanvasGetSize(canvas as cdCanvas ptr, width as integer ptr, height as integer ptr, width_mm as double ptr, height_mm as double ptr)
_DF_ cdCanvasUpdateYAxis(canvas as cdCanvas ptr, y as integer ptr) as integer
_DF_ cdfCanvasUpdateYAxis(canvas as cdCanvas ptr, y as double ptr) as double
_DF_ cdCanvasInvertYAxis(canvas as cdCanvas ptr, y as integer) as integer
_DF_ cdfCanvasInvertYAxis(canvas as cdCanvas ptr, y as double) as double
_DS_ cdCanvasMM2Pixel(canvas as cdCanvas ptr, mm_dx as double, mm_dy as double, dx as integer ptr, dy as integer ptr)
_DS_ cdCanvasPixel2MM(canvas as cdCanvas ptr, dx as integer, dy as integer, mm_dx as double ptr, mm_dy as double ptr)
_DS_ cdfCanvasMM2Pixel(canvas as cdCanvas ptr, mm_dx as double, mm_dy as double, dx as double ptr, dy as double ptr)
_DS_ cdfCanvasPixel2MM(canvas as cdCanvas ptr, dx as double, dy as double, mm_dx as double ptr, mm_dy as double ptr)
_DS_ cdCanvasOrigin(canvas as cdCanvas ptr, x as integer, y as integer)
_DS_ cdfCanvasOrigin(canvas as cdCanvas ptr, x as double, y as double)
_DS_ cdCanvasGetOrigin(canvas as cdCanvas ptr, x as integer ptr, y as integer ptr)
_DS_ cdfCanvasGetOrigin(canvas as cdCanvas ptr, x as double ptr, y as double ptr)
_DS_ cdCanvasTransform(canvas as cdCanvas ptr, matrix as const double ptr)
_DF_ cdCanvasGetTransform(canvas as cdCanvas ptr) as double ptr
_DS_ cdCanvasTransformMultiply(canvas as cdCanvas ptr, matrix as const double ptr)
_DS_ cdCanvasTransformRotate(canvas as cdCanvas ptr, angle as double)
_DS_ cdCanvasTransformScale(canvas as cdCanvas ptr, sx as double, sy as double)
_DS_ cdCanvasTransformTranslate(canvas as cdCanvas ptr, dx as double, dy as double)
_DS_ cdCanvasTransformPoint(canvas as cdCanvas ptr, x as integer, y as integer, tx as integer ptr, ty as integer ptr)
_DS_ cdfCanvasTransformPoint(canvas as cdCanvas ptr, x as double, y as double, tx as double ptr, ty as double ptr)

/' clipping '/
_DF_ cdCanvasClip(canvas as cdCanvas ptr, mode as integer) as integer
_DS_ cdCanvasClipArea(canvas as cdCanvas ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DF_ cdCanvasGetClipArea(canvas as cdCanvas ptr, xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr) as integer
_DS_ cdfCanvasClipArea(canvas as cdCanvas ptr, xmin as double, xmax as double, ymin as double, ymax as double)
_DF_ cdfCanvasGetClipArea(canvas as cdCanvas ptr, xmin as double ptr, xmax as double ptr, ymin as double ptr, ymax as double ptr) as integer

/' clipping region '/
_DF_ cdCanvasIsPointInRegion(canvas as cdCanvas ptr, x as integer, y as integer) as integer
_DS_ cdCanvasOffsetRegion(canvas as cdCanvas ptr, x as integer, y as integer)
_DS_ cdCanvasGetRegionBox(canvas as cdCanvas ptr, xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)
_DF_ cdCanvasRegionCombineMode(canvas as cdCanvas ptr, mode as integer) as integer

/' primitives '/
_DS_ cdCanvasPixel(canvas as cdCanvas ptr, x as integer, y as integer, color as long)
_DS_ cdCanvasMark(canvas as cdCanvas ptr, x as integer, y as integer)

_DS_ cdCanvasBegin(canvas as cdCanvas ptr, mode as integer)
_DS_ cdCanvasPathSet(canvas as cdCanvas ptr, action as integer)
_DS_ cdCanvasEnd(canvas as cdCanvas ptr)

_DS_ cdCanvasLine(canvas as cdCanvas ptr, x1 as integer, y1 as integer, x2 as integer, y2 as integer)
_DS_ cdCanvasVertex(canvas as cdCanvas ptr, x as integer, y as integer)
_DS_ cdCanvasRect(canvas as cdCanvas ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasBox(canvas as cdCanvas ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasArc(canvas as cdCanvas ptr, xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdCanvasSector(canvas as cdCanvas ptr, xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdCanvasChord(canvas as cdCanvas ptr, xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdCanvasText(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr)

_DS_ cdfCanvasLine(canvas as cdCanvas ptr, x1 as double, y1 as double, x2 as double, y2 as double)
_DS_ cdfCanvasVertex(canvas as cdCanvas ptr, x as double, y as double)
_DS_ cdfCanvasRect(canvas as cdCanvas ptr, xmin as double, xmax as double, ymin as double, ymax as double)
_DS_ cdfCanvasBox(canvas as cdCanvas ptr, xmin as double, xmax as double, ymin as double, ymax as double)
_DS_ cdfCanvasArc(canvas as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ cdfCanvasSector(canvas as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ cdfCanvasChord(canvas as cdCanvas ptr, xc as double, yc as double, w as double, h as double, angle1 as double, angle2 as double)
_DS_ cdfCanvasText(canvas as cdCanvas ptr, x as double, y as double, s as const zstring ptr)

/' attributes '/
_DS_ cdCanvasSetBackground(canvas as cdCanvas ptr, color as long)
_DS_ cdCanvasSetForeground(canvas as cdCanvas ptr, color as long)
_DF_ cdCanvasBackground(canvas as cdCanvas ptr, color as long) as long
_DF_ cdCanvasForeground(canvas as cdCanvas ptr, color as long) as long
_DF_ cdCanvasBackOpacity(canvas as cdCanvas ptr, opacity as integer) as integer
_DF_ cdCanvasWriteMode(canvas as cdCanvas ptr, mode as integer) as integer
_DF_ cdCanvasLineStyle(canvas as cdCanvas ptr, style as integer) as integer
_DS_ cdCanvasLineStyleDashes(canvas as cdCanvas ptr, dashes as integer ptr, count as integer)
_DF_ cdCanvasLineWidth(canvas as cdCanvas ptr, width as integer) as integer
_DF_ cdCanvasLineJoin(canvas as cdCanvas ptr, join as integer) as integer
_DF_ cdCanvasLineCap(canvas as cdCanvas ptr, cap as integer) as integer
_DF_ cdCanvasInteriorStyle(canvas as cdCanvas ptr, style as integer) as integer
_DF_ cdCanvasHatch(canvas as cdCanvas ptr, style as integer) as integer
_DS_ cdCanvasStipple(canvas as cdCanvas ptr, w as integer, h as integer, stipple as const ubyte ptr)
_DF_ cdCanvasGetStipple(canvas as cdCanvas ptr, n as integer ptr, m as integer ptr) as zstring ptr
_DS_ cdCanvasPattern(canvas as cdCanvas ptr, w as integer, h as integer, pattern as const long ptr)
_DF_ cdCanvasGetPattern(canvas as cdCanvas ptr, n as integer ptr, m as integer ptr) as long ptr
_DF_ cdCanvasFillMode(canvas as cdCanvas ptr, mode as integer) as integer
_DF_ cdCanvasFont(canvas as cdCanvas ptr, type_face as const zstring ptr, style as integer, size as integer) as integer
_DS_ cdCanvasGetFont(canvas as cdCanvas ptr, type_face as zstring ptr, style as integer ptr, size as integer ptr)
_DF_ cdCanvasNativeFont(canvas as cdCanvas ptr, font as const zstring ptr) as zstring ptr
_DF_ cdCanvasTextAlignment(canvas as cdCanvas ptr, alignment as integer) as integer
_DF_ cdCanvasTextOrientation(canvas as cdCanvas ptr, angle as double) as double
_DF_ cdCanvasMarkType(canvas as cdCanvas ptr, type as integer) as integer
_DF_ cdCanvasMarkSize(canvas as cdCanvas ptr, size as integer) as integer

/' vector text '/
_DS_ cdCanvasVectorText(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr)
_DS_ cdCanvasMultiLineVectorText(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr)

/' vector text attributes '/
_DF_ cdCanvasVectorFont(canvas as cdCanvas ptr, filename as const zstring ptr) as zstring ptr
_DS_ cdCanvasVectorTextDirection(canvas as cdCanvas ptr, x1 as integer, y1 as integer, x2 as integer, y2 as integer)
_DF_ cdCanvasVectorTextTransform(canvas as cdCanvas ptr, matrix as const double ptr) as double ptr
_DS_ cdCanvasVectorTextSize(canvas as cdCanvas ptr, size_x as integer, size_y as integer, s as const zstring ptr)
_DF_ cdCanvasVectorCharSize(canvas as cdCanvas ptr, size as integer) as integer
_DS_ cdCanvasVectorFontSize(canvas as cdCanvas ptr, size_x as double, size_y as double)
_DS_ cdCanvasGetVectorFontSize(canvas as cdCanvas ptr, size_x as double ptr, size_y as double ptr)

/' vector text properties '/
_DS_ cdCanvasGetVectorTextSize(canvas as cdCanvas ptr, s as const zstring ptr, x as integer ptr, y as integer ptr)
_DS_ cdCanvasGetVectorTextBounds(canvas as cdCanvas ptr, s as const zstring ptr, x as integer, y as integer, rect as integer ptr)
_DS_ cdCanvasGetVectorTextBox(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr, ptrxmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)

/' properties '/
_DS_ cdCanvasGetFontDim(canvas as cdCanvas ptr, max_width as integer ptr, height as integer ptr, ascent as integer ptr, descent as integer ptr)
_DS_ cdCanvasGetTextSize(canvas as cdCanvas ptr, s as const zstring ptr, width as integer ptr, height as integer ptr)
_DS_ cdCanvasGetTextBox(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr, xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)
_DS_ cdCanvasGetTextBounds(canvas as cdCanvas ptr, x as integer, y as integer, s as const zstring ptr, rect as integer ptr)
_DF_ cdCanvasGetColorPlanes(canvas as cdCanvas ptr) as integer

/' color '/
_DS_ cdCanvasPalette(canvas as cdCanvas ptr, n as integer, palette as const long ptr, mode as integer)

/' client images '/
_DS_ cdCanvasGetImageRGB(canvas as cdCanvas ptr, r as ubyte ptr, g as ubyte ptr, b as ubyte ptr, x as integer, y as integer, w as integer, h as integer)
_DS_ cdCanvasPutImageRectRGB(canvas as cdCanvas ptr, iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr, b as const ubyte ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasPutImageRectRGBA(canvas as cdCanvas ptr, iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr,b as const ubyte ptr, a as const ubyte ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasPutImageRectMap(canvas as cdCanvas ptr, iw as integer, ih as integer, index as const ubyte ptr, colors as long ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)

/' server images '/
_DF_ cdCanvasCreateImage(canvas as cdCanvas ptr, w as integer, h as integer) as cdImage ptr
_DS_ cdKillImage(image as cdImage ptr)
_DS_ cdCanvasGetImage(canvas as cdCanvas ptr, image as cdImage ptr, x as integer, y as integer)
_DS_ cdCanvasPutImageRect(canvas as cdCanvas ptr, image as cdImage ptr, x as integer, y as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasScrollArea(canvas as cdCanvas ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer, dx as integer, dy as integer)

/' bitmap '/
_DF_ cdCreateBitmap(w as integer, h as integer, type as integer) as cdBitmap ptr
_DF_ cdInitBitmap(w as integer, h as integer, type as integer, ...) as cdBitmap ptr
_DS_ cdKillBitmap(bitmap as cdBitmap ptr)
_DF_ cdBitmapGetData(bitmap as cdBitmap ptr, dataptr as integer) as ubyte ptr
_DS_ cdBitmapSetRect(bitmap as cdBitmap ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdCanvasPutBitmap(canvas as cdCanvas ptr, bitmap as cdBitmap ptr, x as integer, y as integer, w as integer, h as integer)
_DS_ cdCanvasGetBitmap(canvas as cdCanvas ptr, bitmap as cdBitmap ptr, x as integer, y as integer)
_DS_ cdBitmapRGB2Map(bitmap_rgb as cdBitmap ptr, bitmap as cdBitmap ptr)

/' color '/
_DF_ cdEncodeColor(red as ubyte, green as ubyte, blue as ubyte) as long
_DS_ cdDecodeColor(color as long, red as ubyte ptr, green as ubyte ptr, blue as ubyte ptr)
_DF_ cdDecodeAlpha(color as long) as ubyte
_DF_ cdEncodeAlpha(color as long, alpha as ubyte) as long



/' client image color convertion '/
_DS_ cdRGB2Map(w as integer, h as integer, red as const ubyte ptr, green as const ubyte ptr, blue as const ubyte ptr, index as ubyte ptr, pal_size as integer, color as long ptr)

end extern

#define cdAlpha(x)    cubyte(not((x shr 24)) and &HFF))
#define cdReserved(x) cubyte((x shr 24) and &HFF)
#define cdRed(x)      cubyte((x shr 16) and &HFF)
#define cdGreen(x)    cubyte((x shr  8) and &HFF)
#define cdBlue(x)     cubyte(x and &HFF)




/' CD Values '/

#define CD_QUERY -1             /' query value '/

/' bitmap type these definitions are compatible with the IM library '/
enum                        
 CD_RGB,                      
 CD_MAP,
 CD_RGBA = &H100 
end enum
/' bitmap data '/
enum
 CD_IRED,
 CD_IGREEN,
 CD_IBLUE,
 CD_IALPHA,
 CD_INDEX,
 CD_COLORS
end enum

/' status report '/
enum
 CD_ERROR = -1,
 CD_OK    =  0
end enum

/' clip mode '/
enum
 CD_CLIPOFF,
 CD_CLIPAREA,
 CD_CLIPPOLYGON,
 CD_CLIPREGION
end enum

/' region combine mode '/
enum
 CD_UNION,
 CD_INTERSECT,
 CD_DIFFERENCE,
 CD_NOTINTERSECT
end enum

/' polygon mode (begin...end) '/
enum
 CD_FILL,
 CD_OPEN_LINES,
 CD_CLOSED_LINES,
 CD_CLIP,
 CD_BEZIER,
 CD_REGION,
 CD_PATH
end enum

#define CD_POLYCUSTOM 10

/' path actions '/
enum
 CD_PATH_NEW,
 CD_PATH_MOVETO,
 CD_PATH_LINETO,
 CD_PATH_ARC,
 CD_PATH_CURVETO,
 CD_PATH_CLOSE,
 CD_PATH_FILL,
 CD_PATH_STROKE,
 CD_PATH_FILLSTROKE,
 CD_PATH_CLIP
end enum

/' fill mode '/
enum
 CD_EVENODD,
 CD_WINDING
end enum

/' line join  '/
enum
 CD_MITER,
 CD_BEVEL,
 CD_ROUND
end enum  

/' line cap  '/
enum
 CD_CAPFLAT,  
 CD_CAPSQUARE,
 CD_CAPROUND
end enum  

/' background opacity mode '/
enum
 CD_OPAQUE,
 CD_TRANSPARENT
end enum

/' write mode '/
enum
 CD_REPLACE,
 CD_XOR,
 CD_NOT_XOR
end enum

/' color allocation mode (palette) '/
enum
 CD_POLITE,
 CD_FORCE
end enum

/' line style '/
enum
 CD_CONTINUOUS,
 CD_DASHED,
 CD_DOTTED,
 CD_DASH_DOT,
 CD_DASH_DOT_DOT,
 CD_CUSTOM
end enum

/' marker type '/
enum
 CD_PLUS,
 CD_STAR,
 CD_CIRCLE,
 CD_X,
 CD_BOX,
 CD_DIAMOND,
 CD_HOLLOW_CIRCLE,
 CD_HOLLOW_BOX,
 CD_HOLLOW_DIAMOND
end enum

/' hatch type '/
enum
 CD_HORIZONTAL,
 CD_VERTICAL,
 CD_FDIAGONAL,
 CD_BDIAGONAL,
 CD_CROSS,
 CD_DIAGCROSS
end enum

/' interior style '/
enum
 CD_SOLID,
 CD_HATCH,
 CD_STIPPLE,
 CD_PATTERN,
 CD_HOLLOW
end enum

/' text alignment '/
enum
 CD_NORTH,
 CD_SOUTH,
 CD_EAST,
 CD_WEST,
 CD_NORTH_EAST,
 CD_NORTH_WEST,
 CD_SOUTH_EAST,
 CD_SOUTH_WEST,
 CD_CENTER,
 CD_BASE_LEFT,
 CD_BASE_CENTER,
 CD_BASE_RIGHT
end enum

/' style '/
enum
 CD_PLAIN  = 0,
 CD_BOLD   = 1,
 CD_ITALIC = 2,
 CD_UNDERLINE = 4,
 CD_STRIKEOUT = 8
end enum

/' compatibility name '/
#define CD_BOLD_ITALIC (CD_BOLD or CD_ITALIC)  

/' some font sizes '/
enum
  CD_SMALL    =  8,
  CD_STANDARD = 12,
  CD_LARGE    = 18
end enum

/' Context Capabilities '/
#define CD_CAP_NONE             &H00000000
#define CD_CAP_FLUSH            &H00000001
#define CD_CAP_CLEAR            &H00000002
#define CD_CAP_PLAY             &H00000004
#define CD_CAP_YAXIS            &H00000008
#define CD_CAP_CLIPAREA         &H00000010
#define CD_CAP_CLIPPOLY         &H00000020
#define CD_CAP_REGION           &H00000040
#define CD_CAP_RECT             &H00000080
#define CD_CAP_CHORD            &H00000100
#define CD_CAP_IMAGERGB         &H00000200
#define CD_CAP_IMAGERGBA        &H00000400
#define CD_CAP_IMAGEMAP         &H00000800
#define CD_CAP_GETIMAGERGB      &H00001000
#define CD_CAP_IMAGESRV         &H00002000
#define CD_CAP_BACKGROUND       &H00004000
#define CD_CAP_BACKOPACITY      &H00008000
#define CD_CAP_WRITEMODE        &H00010000
#define CD_CAP_LINESTYLE        &H00020000
#define CD_CAP_LINEWITH         &H00040000
#define CD_CAP_FPRIMTIVES       &H00080000
#define CD_CAP_HATCH            &H00100000
#define CD_CAP_STIPPLE          &H00200000
#define CD_CAP_PATTERN          &H00400000
#define CD_CAP_FONT             &H00800000
#define CD_CAP_FONTDIM          &H01000000
#define CD_CAP_TEXTSIZE         &H02000000
#define CD_CAP_TEXTORIENTATION  &H04000000
#define CD_CAP_PALETTE          &H08000000
#define CD_CAP_LINECAP          &H10000000
#define CD_CAP_LINEJOIN         &H20000000
#define CD_CAP_PATH             &H40000000
#define CD_CAP_BEZIER           &H80000000
#define CD_CAP_ALL              &HFFFFFFFF

/' Context Types '/
enum 
  CD_CTX_WINDOW, 
  CD_CTX_DEVICE, 
  CD_CTX_IMAGE,
  CD_CTX_FILE
end enum

/' cdPlay definitions '/
#define CD_SIZECB 0        /' size callback '/

#define CD_ABORT 1
#define CD_CONTINUE 0

/' simulation flags '/
#define CD_SIM_NONE         &H0000
#define CD_SIM_LINE         &H0001
#define CD_SIM_RECT         &H0002
#define CD_SIM_BOX          &H0004
#define CD_SIM_ARC          &H0008
#define CD_SIM_SECTOR       &H0010
#define CD_SIM_CHORD        &H0020
#define CD_SIM_POLYLINE     &H0040
#define CD_SIM_POLYGON      &H0080
#define CD_SIM_TEXT         &H0100
#define CD_SIM_ALL          &HFFFF

#define CD_SIM_LINES (CD_SIM_LINE or CD_SIM_RECT or CD_SIM_ARC or CD_SIM_POLYLINE)
#define CD_SIM_FILLS (CD_SIM_BOX or CD_SIM_SECTOR or CD_SIM_CHORD or CD_SIM_POLYGON)

/' some predefined colors for convenience '/
#define  CD_RED           &HFF0000L   /' 255,  0,  0 '/
#define  CD_DARK_RED      &H800000L   /' 128,  0,  0 '/
#define  CD_GREEN         &H00FF00L   /'   0,255,  0 '/
#define  CD_DARK_GREEN    &H008000L   /'   0,128,  0 '/
#define  CD_BLUE          &H0000FFL   /'   0,  0,255 '/
#define  CD_DARK_BLUE     &H000080L   /'   0,  0,128 '/

#define  CD_YELLOW        &HFFFF00L   /' 255,255,  0 '/
#define  CD_DARK_YELLOW   &H808000L   /' 128,128,  0 '/
#define  CD_MAGENTA       &HFF00FFL   /' 255,  0,255 '/
#define  CD_DARK_MAGENTA  &H800080L   /' 128,  0,128 '/
#define  CD_CYAN          &H00FFFFL   /'   0,255,255 '/
#define  CD_DARK_CYAN     &H008080L   /'   0,128,128 '/

#define  CD_WHITE         &HFFFFFFL   /' 255,255,255 '/
#define  CD_BLACK         &H000000L   /'   0,  0,  0 '/

#define  CD_DARK_GRAY     &H808080L   /' 128,128,128 '/
#define  CD_GRAY          &HC0C0C0L   /' 192,192,192 '/

/' some usefull conversion factors '/
#define CD_MM2PT     2.834645669   /' milimeters to points (pt = CD_MM2PT * mm) '/
#define CD_RAD2DEG  57.295779513   /' radians to degrees (deg = CD_RAD2DEG * rad) '/
#define CD_DEG2RAD  0.01745329252  /' degrees to radians (rad = CD_DEG2RAD * deg) '/

/' paper sizes '/
enum 
  CD_A0,
  CD_A1,
  CD_A2,
  CD_A3,
  CD_A4,
  CD_A5,
  CD_LETTER,
  CD_LEGAL
end enum

#ifndef CD_NO_OLD_INTERFACE
#include once "cd_old.bi"
#endif

#endif ' __CD_BI__
