#ifndef __CD_OLD_BI__
#define __CD_OLD_BI__

' see copyright notice at the file iup.txt
#include once "iup.bi"
#include once "cd.bi"

extern "c"

/' canvas control '/
_DF_ cdActivate( canvas as cdCanvas ptr) as integer
_DF_ cdActiveCanvas() as cdCanvas ptr
_DF_ cdSimulate( mode as integer) as integer
_DS_ cdFlush()
_DS_ cdClear()
_DF_ cdSaveState() as cdState ptr
_DS_ cdRestoreState (state as cdState ptr)
_DS_ cdSetAttribute (name as const zstring ptr, data as zstring ptr)
_DS_ cdSetfAttribute(name as const zstring ptr, format as const zstring ptr, ...)
_DF_ cdGetAttribute (name as const zstring ptr) as zstring ptr
_DF_ cdGetContext   (canvas as cdCanvas ptr) as cdContext ptr

/' interpretation '/
_DF_ cdRegisterCallback(context as cdContext ptr, cb as integer,func as cdCallback) as integer
_DF_ cdPlay            (context as cdContext ptr, xmin as integer, xmax as integer, ymin as integer, ymax as integer, data as any ptr) as integer

/' coordinate transformation '/
_DS_ cdGetCanvasSize(w as integer ptr, h as integer ptr, width_mm as double ptr, height_mm as double ptr)
_DF_ cdUpdateYAxis(y as integer ptr) as integer
_DS_ cdMM2Pixel(mm_dx as double, mm_dy as double, dx as integer ptr, dy as integer ptr)
_DS_ cdPixel2MM(dx as integer, dy as integer, mm_dx as double ptr, mm_dy as double ptr)
_DS_ cdOrigin(x as integer, y as integer)

/' clipping '/
_DF_ cdClip(mode as integer) as integer
_DF_ cdGetClipPoly(n as integer ptr) as integer ptr
_DS_ cdClipArea(xmin as integer, xmax as integer, ymin as integer, ymax as integer) 
_DF_ cdGetClipArea(xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)  as integer 

/' clipping region '/
_DF_ cdPointInRegion(x as integer, y as integer)  as integer
_DS_ cdOffsetRegion(x as integer, y as integer)
_DS_ cdRegionBox(xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)
_DF_ cdRegionCombineMode(mode as integer) as integer

/' primitives '/
_DS_ cdPixel(x as integer, y as integer, color_ as long)
_DS_ cdMark(x as integer, y as integer)
_DS_ cdLine(x1 as integer, y1 as integer, x2 as integer, y2 as integer)
_DS_ cdBegin(mode as integer)
_DS_ cdVertex(x as integer, y as integer)
_DS_ cdEnd()
_DS_ cdRect(xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdBox(xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdArc(xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdSector(xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdChord(xc as integer, yc as integer, w as integer, h as integer, angle1 as double, angle2 as double)
_DS_ cdText(x as integer, y as integer, s as const zstring ptr)
/' attributes '/
_DF_ cdBackground(color_ as long) as long 
_DF_ cdForeground(color_ as long) as long
_DF_ cdBackOpacity(opacity as integer) as integer
_DF_ cdWriteMode(mode as integer) as integer
_DF_ cdLineStyle(style as integer) as integer
_DS_ cdLineStyleDashes(dashes as const integer ptr, count as integer)
_DF_ cdLineWidth(w as integer) as integer
_DF_ cdLineJoin(join as integer) as integer
_DF_ cdLineCap(cap as integer) as integer
_DF_ cdInteriorStyle(style as integer) as integer
_DF_ cdHatch(style as integer) as integer
_DS_ cdStipple(w as integer, h as integer, stipple as const ubyte ptr)
_DF_ cdGetStipple(n as integer ptr, m as integer ptr) as ubyte ptr
_DS_ cdPattern(w as integer, h as integer, pattern as long ptr)
_DF_ cdGetPattern(n as integer ptr, m as integer ptr) as long ptr
_DF_ cdFillMode(mode as integer) as integer
_DS_ cdFont(type_face as integer, style as integer, size as integer)
_DS_ cdGetFont(type_face as integer ptr, style as integer ptr, size as integer ptr)
_DF_ cdNativeFont(font as const zstring ptr) as zstring ptr
_DF_ cdTextAlignment(alignment as integer) as integer
_DF_ cdTextOrientation(angle as double) as double
_DF_ cdMarkType(type_ as integer) as integer
_DF_ cdMarkSize(size as integer) as integer

/' vector text '/
_DS_ cdVectorText(x as integer, y as integer, s as const zstring ptr)
_DS_ cdMultiLineVectorText(x as integer, y as integer, s as const zstring ptr)

/' vector text attributes '/
_DF_ cdVectorFont(filename as const zstring ptr) as zstring ptr
_DS_ cdVectorTextDirection(x1 as integer, y1 as integer, x2 as integer, y2 as integer)
_DF_ cdVectorTextTransform(matrix as const double ptr) as double ptr
_DS_ cdVectorTextSize(size_x as integer, size_y as integer, s as const zstring ptr)
_DF_ cdVectorCharSize(size as integer) as integer

/' vector text properties '/
_DS_ cdGetVectorTextSize(s as const zstring ptr, x as integer ptr, y as integer ptr)
_DS_ cdGetVectorTextBounds(s as const zstring ptr, x as integer, y as integer, rect as integer ptr)

/' properties '/
_DS_ cdFontDim(max_width as integer ptr, height as integer ptr, ascent as integer ptr, descent as integer ptr)
_DS_ cdTextSize(s as const zstring ptr, w as integer ptr, h as integer ptr)
_DS_ cdTextBox(x as integer, y as integer, s as const zstring ptr, xmin as integer ptr, xmax as integer ptr, ymin as integer ptr, ymax as integer ptr)
_DS_ cdTextBounds(x as integer, y as integer, s as const zstring ptr, rect as integer ptr)
_DF_ cdGetColorPlanes() as integer

/' color '/
_DS_ cdPalette(n as integer, palette_ as const long ptr, mode as integer)

/' client images '/
_DS_ cdGetImageRGB(r as ubyte ptr, g as ubyte ptr, b as ubyte ptr, x as integer, y as integer, w as integer, h as integer)
_DS_ cdPutImageRectRGB (iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr, b as const ubyte ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdPutImageRectRGBA(iw as integer, ih as integer, r as const ubyte ptr, g as const ubyte ptr, b as const ubyte ptr, a as const ubyte ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdPutImageRectMap (iw as integer, ih as integer, index as const ubyte ptr, colors as const long ptr, x as integer, y as integer, w as integer, h as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)

/' server images '/
_DF_ cdCreateImage(w as integer, h as integer) as cdImage ptr
_DS_ cdGetImage(image as cdImage ptr, x as integer, y as integer)
_DS_ cdPutImageRect(image as cdImage ptr, x as integer, y as integer, xmin as integer, xmax as integer, ymin as integer, ymax as integer)
_DS_ cdScrollArea(xmin as integer, xmax as integer, ymin as integer, ymax as integer, dx as integer, dy as integer)

/' bitmap '/
_DS_ cdPutBitmap(bitmap as cdBitmap ptr, x as integer, y as integer, w as integer, h as integer)
_DS_ cdGetBitmap(bitmap as cdBitmap ptr, x as integer, y as integer)

end extern

/' defined for backward compatibility '/
#define cdPutImageRGB(iw, ih, r, g, b, x, y, w, h) cdPutImageRectRGB((iw), (ih), (r), (g), (b), (x), (y), (w), (h), 0, 0, 0, 0)
#define cdPutImageRGBA(iw, ih, r, g, b, a, x, y, w, h) cdPutImageRectRGBA((iw), (ih), (r), (g), (b), (a), (x), (y), (w), (h), 0, 0, 0, 0)
#define cdPutImageMap(iw, ih, index, colors, x, y, w, h) cdPutImageRectMap((iw), (ih), (index), (colors), (x), (y), (w), (h), 0, 0, 0, 0)
#define cdPutImage(image, x, y) cdPutImageRect((image), (x), (y), 0, 0, 0, 0)


enum /' OLD type face ->  new names '/
 CD_SYSTEM,                     /' "System"    '/
 CD_COURIER,                    /' "Courier"   '/
 CD_TIMES_ROMAN,                /' "Times"     '/
 CD_HELVETICA,                  /' "Helvetica" '/
 CD_NATIVE
end enum

/' OLD definitions, defined for backward compatibility '/
#define CD_CLIPON       CD_CLIPAREA   
#define CD_CENTER_BASE  CD_BASE_CENTER
#define CD_LEFT_BASE    CD_BASE_LEFT
#define CD_RIGHT_BASE   CD_BASE_RIGHT
#define CD_ITALIC_BOLD  CD_BOLD_ITALIC
#define cdScrollImage cdScrollArea

#macro cdCanvas2Raster(x, y) 
  cdUpdateYAxis(y)
#endmacro


#endif
