#ifndef __IM_CAPTURE_BI__
#define __IM_CAPTURE_BI__

' see copyright notice at the file iup.txt


#ifdef __FB_WIN32__
# ifndef IUP_DLL
#  error im_capture must be linked dynamic define IUP_DLL
# endif
#else
 error platform must be windows !
#endif

#include once "iup.bi"

#inclib "im_capture"


type _imVideoCapture as any : type imVideoCapture as _imVideoCapture

extern "c"

_DF_ imVideoCaptureDeviceCount() as integer
_DF_ imVideoCaptureDeviceDesc(device as integer) as zstring ptr
_DF_ imVideoCaptureDeviceExDesc(device as integer) as zstring ptr
_DF_ imVideoCaptureDevicePath(device as integer) as zstring ptr
_DF_ imVideoCaptureDeviceVendorInfo(device as integer) as zstring ptr
_DF_ imVideoCaptureReloadDevices() as integer
_DF_ imVideoCaptureCreate() as imVideoCapture ptr 
_DS_ imVideoCaptureDestroy(vc as imVideoCapture ptr)
_DF_ imVideoCaptureConnect(vc as imVideoCapture ptr, device as integer) as integer
_DS_ imVideoCaptureDisconnect(vc as imVideoCapture ptr)
_DF_ imVideoCaptureDialogCount(vc as imVideoCapture ptr) as integer
_DF_ imVideoCaptureShowDialog(vc as imVideoCapture ptr, dialog as integer, parent as any ptr) as integer
_DF_ imVideoCaptureSetInOut(vc as imVideoCapture ptr, input as integer, output as integer, cross as integer) as integer
_DF_ imVideoCaptureDialogDesc(vc as imVideoCapture ptr, dialog as integer)  as const zstring ptr
_DF_ imVideoCaptureFormatCount(vc as imVideoCapture ptr) as integer
_DF_ imVideoCaptureGetFormat(vc as imVideoCapture ptr, format as integer, w as integer ptr, h as integer ptr, desc as zstring ptr) as integer
_DF_ imVideoCaptureSetFormat(vc as imVideoCapture ptr, format as integer) as integer
_DS_ imVideoCaptureGetImageSize(vc as imVideoCapture ptr, w as integer ptr, h as integer ptr)
_DF_ imVideoCaptureSetImageSize(vc as imVideoCapture ptr, w as integer, h as integer) as integer
_DF_ imVideoCaptureFrame(vc as imVideoCapture ptr, data as ubyte ptr, color_mode as integer, timeout as integer) as integer
_DF_ imVideoCaptureOneFrame(vc as imVideoCapture ptr, data as ubyte ptr, color_mode as integer) as integer
_DF_ imVideoCaptureLive(vc as imVideoCapture ptr, live as integer) as integer 
_DF_ imVideoCaptureResetAttribute(vc as imVideoCapture ptr, attrib as const zstring ptr, fauto as integer) as integer
_DF_ imVideoCaptureGetAttribute(vc as imVideoCapture ptr, attrib as const zstring ptr, percent as single ptr) as integer
_DF_ imVideoCaptureSetAttribute(vc as imVideoCapture ptr, attrib as const zstring ptr, percent as single) as integer
_DF_ imVideoCaptureGetAttributeList(vc as imVideoCapture ptr, num_attrib as integer ptr) as const zstring ptr ptr


/'defgroup winattrib Windows Attributes Names
 * Not all attributes are supported by each device.
 * Use the return value of \ref imVideoCaptureGetAttribute to check if the attribute is supported.
  VideoBrightness - Specifies the brightness, also called the black level. 
  VideoContrast - Specifies the contrast, expressed as gain factor. 
  VideoHue - Specifies the hue angle. 
  VideoSaturation - Specifies the saturation.
  VideoSharpness - Specifies the sharpness. 
  VideoGamma - Specifies the gamma. 
  VideoColorEnable - Specifies the color enable setting. (0/100)
  VideoWhiteBalance - Specifies the white balance, as a color temperature in degrees Kelvin. 
  VideoBacklightCompensation - Specifies the backlight compensation setting. (0/100)
  VideoGain - Specifies the gain adjustment.
  CameraPanAngle - Specifies the camera's pan angle. To 100 rotate right, To 0 rotate left (view from above).
  CameraTiltAngle - Specifies the camera's tilt angle.  To 100 rotate up, To 0 rotate down.
  CameraRollAngle - Specifies the camera's roll angle. To 100 rotate right, To 0 rotate left.
  CameraLensZoom - Specifies the camera's zoom setting. 
  CameraExposure - Specifies the exposure setting. 
  CameraIris - Specifies the camera's iris setting. 
  CameraFocus - Specifies the camera's focus setting, as the distance to the optimally focused target. 
  FlipHorizontal - Specifies the video will be flipped in the horizontal direction.
  FlipVertical - Specifies the video will be flipped in the vertical direction.
  AnalogFormat - Specifies the video format standard NTSC, PAL, etc. Valid values:
      NTSC_M     = 0 
      NTSC_M_J   = 1  
      NTSC_433   = 2
      PAL_B      = 3
      PAL_D      = 4
      PAL_H      = 5
      PAL_I      = 6
      PAL_M      = 7
      PAL_N      = 8
      PAL_60     = 9
      SECAM_B    = 10
      SECAM_D    = 11
      SECAM_G    = 12
      SECAM_H    = 13
      SECAM_K    = 14
      SECAM_K1   = 15
      SECAM_L    = 16
      SECAM_L1   = 17
      PAL_N_COMBO = 18
 * \ingroup capture '/

end extern

#if 0
/** A C++ Wrapper for the imVideoCapture structure functions.
 * \ingroup capture */
class imCapture
{
public:
  imCapture() 
    { vc = imVideoCaptureCreate(); }
  
  ~imCapture() 
    { if (vc) imVideoCaptureDestroy(vc); }
  
  int Failed() 
    { if (!vc) return 0; else return 1; }
  
  int Connect(device as integer) 
    { return imVideoCaptureConnect(vc, device); }
  
  void Disconnect() 
    { imVideoCaptureDisconnect(vc); }
  
  int DialogCount() 
    { return imVideoCaptureDialogCount(vc); }
  
  int ShowDialog(int dialog, void* parent) 
    { return imVideoCaptureShowDialog(vc, dialog, parent); }
  
  const char* DialogDescription(int dialog) 
    { return imVideoCaptureDialogDesc(vc, dialog); }

  int FormatCount()
    { return imVideoCaptureFormatCount(vc); }

  int GetFormat(int format, int *width, int *height, char* desc)
    { return imVideoCaptureGetFormat(vc, format, width, height, desc); }

  int SetFormat(int format)
    { return imVideoCaptureSetFormat(vc, format); }
  
  void GetImageSize(int *width, int *height) 
    { imVideoCaptureGetImageSize(vc, width, height); }
  
  int SetImageSize(int width, int height) 
    { return imVideoCaptureSetImageSize(vc, width, height); }
  
  int GetFrame(unsigned char* data, int color_mode, int timeout) 
    { return imVideoCaptureFrame(vc, data, color_mode, timeout); }
  
  int GetOneFrame(unsigned char* data, int color_mode) 
    { return imVideoCaptureOneFrame(vc, data, color_mode); }
  
  int Live(int live) 
    { return imVideoCaptureLive(vc, live); }
  
  int ResetAttribute(const char* attrib, int fauto) 
    { return imVideoCaptureResetAttribute(vc, attrib, fauto); }
  
  int GetAttribute(const char* attrib, float *percent) 
    { return imVideoCaptureGetAttribute(vc, attrib, percent); }
  
  int SetAttribute(const char* attrib, float percent) 
    { return imVideoCaptureSetAttribute(vc, attrib, percent); }
  
  const char** GetAttributeList(int *num_attrib) 
    { return imVideoCaptureGetAttributeList(vc, num_attrib); }
  
protected:
  vc as imVideoCapture ptr;
};
#endif

#endif
