#include once "fltk-c.bi"

dim as zstring ptr cat_xpm(...) => { _
@"50 34 4 1", _
@"  c black", _
@"o c #ff8800", _
@"@ c #ffffff", _
@"# c None", _
@"##################################################", _
@"###      ##############################       ####", _
@"### ooooo  ###########################  ooooo ####", _
@"### oo  oo  #########################  oo  oo ####", _
@"### oo   oo  #######################  oo   oo ####", _
@"### oo    oo  #####################  oo    oo ####", _
@"### oo     oo  ###################  oo     oo ####", _
@"### oo      oo                     oo      oo ####", _
@"### oo       oo  ooooooooooooooo  oo       oo ####", _
@"### oo        ooooooooooooooooooooo        oo ####", _
@"### oo     ooooooooooooooooooooooooooo    ooo ####", _
@"#### oo   ooooooo ooooooooooooo ooooooo   oo #####", _
@"####  oo oooooooo ooooooooooooo oooooooo oo  #####", _
@"##### oo oooooooo ooooooooooooo oooooooo oo ######", _
@"#####  o ooooooooooooooooooooooooooooooo o  ######", _
@"###### ooooooooooooooooooooooooooooooooooo #######", _
@"##### ooooooooo     ooooooooo     ooooooooo ######", _
@"##### oooooooo  @@@  ooooooo  @@@  oooooooo ######", _
@"##### oooooooo @@@@@ ooooooo @@@@@ oooooooo ######", _
@"##### oooooooo @@@@@ ooooooo @@@@@ oooooooo ######", _
@"##### oooooooo  @@@  ooooooo  @@@  oooooooo ######", _
@"##### ooooooooo     ooooooooo     ooooooooo ######", _
@"###### oooooooooooooo       oooooooooooooo #######", _
@"###### oooooooo@@@@@@@     @@@@@@@oooooooo #######", _
@"###### ooooooo@@@@@@@@@   @@@@@@@@@ooooooo #######", _
@"####### ooooo@@@@@@@@@@@ @@@@@@@@@@@ooooo ########", _
@"######### oo@@@@@@@@@@@@ @@@@@@@@@@@@oo ##########", _
@"########## o@@@@@@ @@@@@ @@@@@ @@@@@@o ###########", _
@"########### @@@@@@@     @     @@@@@@@ ############", _
@"############  @@@@@@@@@@@@@@@@@@@@@  #############", _
@"##############  @@@@@@@@@@@@@@@@@  ###############", _
@"################    @@@@@@@@@    #################", _
@"####################         #####################", _
@"##################################################"}

function HandleCB cdecl (self as any ptr, event as Fl_Event) as integer
  static as integer ox = 0
  static as integer oy = 0
  select case as const event
  case FL_EVENT_PUSH
    ox = Fl_WidgetGetX(self)-Fl_EventX() ' save where user clicked for dragging
    oy = Fl_WidgetGetY(self)-Fl_EventY()
    Fl_WidgetSetBox self,2
    Fl_WidgetRedraw Fl_WidgetWindow(self)
    return 1
  case FL_EVENT_RELEASE
    Fl_WidgetSetBox self,0
    Fl_WidgetRedraw Fl_WidgetWindow(self)
    return 1
  case FL_EVENT_DRAG
    Fl_WidgetPosition self,ox+Fl_EventX(), oy+Fl_EventY() ' handle dragging
    Fl_WidgetRedraw Fl_WidgetWindow(self)
    return 1
  end select
  return 0
end function
'
' main
'
var win = Fl_Double_WindowNew(Fl_GetW()*0.75,Fl_GetH()*0.75,"dragable boxes")
var scl = Fl_ScrollNew(10,10,Fl_WidgetGetW(win)-20,Fl_WidgetGetH(win)-20)
var cat = Fl_PixmapNew(@cat_xpm(0))
Fl_GroupBegin scl
  for y as integer =0 to 31
    for x as integer =0 to 31
      var box = Fl_BoxExNew(x*90,y*60,80,50)
      Fl_BoxExSetHandleCB box,@HandleCB
      Fl_WidgetSetImage   box,cat
    next
  next
Fl_GroupEnd scl
Fl_GroupSetResizable win,scl
Fl_WindowShow win
Fl_Run


