#include once "fltk-c.bi"
' private test of:
' Fl_GroupSetResizable  http://www.fltk.org/doc-1.3/classFl__Group.html#afd220e45e1ac817bde7d6a25fdf74e37

#define Fl_TabNew Fl_GroupNew
#define Fl_TabEnd Fl_GroupEnd
#define Fl_TabsEnd Fl_GroupEnd

const BOX_STYLE = FL_UP_BOX

const TB=32
const SB=24
const TW=160
const TH=16

' get screensize and calculate window size
dim as integer sw = Fl_GetW(),ww=sw\2
dim as integer sh = Fl_GetH(),wh=sh\2

' create a centered flicker free (double buffered) window
dim as FL_WINDOW ptr win = Fl_Double_WindowNew2(ww\2,wh\2,ww,wh, "resize me ...")

Fl_WindowBegin win ' open the child list
  dim as integer bw = ww\4,bh = wh\4
  dim as FL_BOX ptr box

  ' simulate top aligned fixed horizonzal bar (may be a toolbar)
  Fl_BoxNew2(BOX_STYLE,0,0,ww,TB)

  ' simulate left aligned fixed vertical bar
  Fl_BoxNew2(BOX_STYLE, 0    ,TB,TB    ,wh-(TB+SB))

  ' resizeable client region in center
  box=Fl_BoxNew2(FL_FLAT_BOX,TB,TB,ww-(TB+TW),wh-(TB+SB)) : Fl_WidgetSetColor box,FL_BLACK
  
  ' simulate right aligned fixed vertical bar
  var tabs = Fl_TabsNew (ww-TW,TB   ,TW,wh-(TB+SB))
    var tab1 = Fl_TabNew(ww-TW,TB+TH,TW,wh-(TB+SB+TH),"tab1")
    Fl_TabEnd tab1
    var tab2 = Fl_TabNew(ww-TW,TB+TH,TW,wh-(TB+SB+TH),"tab2")
    Fl_TabEnd tab2
    var tab3 = Fl_TabNew(ww-TW,TB+TH,TW,wh-(TB+SB+TH),"tab3")
    Fl_TabEnd tab3
    var tab4 = Fl_TabNew(ww-TW,TB+TH,TW,wh-(TB+SB+TH),"tab4")
    Fl_TabEnd tab4
  Fl_TabsEnd tabs

  ' simulate bottom aligned bar (may be a status bar)
  Fl_BoxNew2(BOX_STYLE,0   ,wh-SB,ww\2,SB)
  Fl_BoxNew2(BOX_STYLE,ww\2+ww/8*0,wh-SB,ww\8,SB)
  Fl_BoxNew2(BOX_STYLE,ww\2+ww/8*1,wh-SB,ww\8,SB)
  Fl_BoxNew2(BOX_STYLE,ww\2+ww/8*2,wh-SB,ww\8,SB)
  Fl_BoxNew2(BOX_STYLE,ww\2+ww/8*3,wh-SB,ww\8,SB)

Fl_WindowEnd win ' close the child list

Fl_GroupSetResizable win,box ' the black box and it's row defines the resizeable behavior of all other boxes

Fl_WindowShow win ' bring the window on the screen

Fl_Run ' enter the message loop
