#include once "fltk-c.bi"

' test of class Fl_Preferences 
' http://www.fltk.org/doc-1.3/classFl__Preferences.html

' create a preferences db
dim as Fl_Preferences ptr db = Fl_PreferencesNew(FL_Root.User,"vendor.xxx","myapp")

' create a group in the db 
dim as Fl_Preferences ptr group = Fl_PreferencesNewGroup(db,"mygroup")

' write some integer values
for i as integer=0 to 3
  Fl_PreferencesSetInt(group,"key_i_" & i,i)
next

' write a float value
Fl_PreferencesSetFloat(group,"key_f",123.4)
' write a double value
Fl_PreferencesSetDouble(group,"key_d",123.456789)
' write a double with precision count of 10
Fl_PreferencesSetDouble2(group,"key_d2",123.456789,10)
' write a string value
Fl_PreferencesSetString(group,"key_s","i'm a string")
' close the db
Fl_PreferencesDelete db

' open a preferences db
db = Fl_PreferencesNew(FL_Root.User,"vendor.xxx","myapp")
' open a group
group = Fl_PreferencesNewGroup(db,"mygroup")
' read some integers
dim as integer iValue
for i as integer=0 to 3
  Fl_PreferencesGetInt(group,"key_i_" & i,iValue,0)
  print iValue
next
' read a single value
dim as single fValue
Fl_PreferencesGetFloat(group,"key_f",fValue,0.0)
print fValue
' read a double value
dim as double dValue
Fl_PreferencesGetDouble(group,"key_d",dValue,0.0)
print dValue
' read a double value
Fl_PreferencesGetDouble(group,"key_d2",dValue,0.0)
print dValue
' read a string value
dim as zstring ptr sValue = callocate(255)
Fl_PreferencesGetString(group,"key_s",sValue,"")
print *sValue
deallocate sValue

Fl_PreferencesDelete db

sleep


