/'
	BASS simple DSP test
	Copyright (c) 2000-2012 Un4seen Developments Ltd.
'/
' *** adapted for FreeBasic by electrik

#include "windows.bi"
#include "win/commdlg.bi"
#include "crt/stdio.bi"
#include "bass.bi"

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

dim shared as HWND win=NULL

dim shared as DWORD floatable ' floating-point channel support?
dim shared as DWORD chan	' the channel... HMUSIC or HSTREAM

dim shared as OPENFILENAME ofn

' display error messages
sub ErrorMess(byval es as const zstring ptr)
	dim as zstring  * 200 mes
	sprintf(mes,@"%s\n(error code: %d)",es,BASS_ErrorGetCode())
	MessageBox(win,mes,0,0)
end sub

' macro-command fmod
#define fmod(a,b) ((a) - Fix((a) / (b)) * (b))

' "rotate"
dim shared as HDSP rotdsp=0	' DSP handle
dim shared as single rotpos	' cur.pos
sub Rotate(byval handle as HDSP, byval channel as DWORD, byval buffer as any ptr, byval length as DWORD, byval user as any ptr)
	dim as single ptr d=buffer
	dim as DWORD a

	for a=0 to length/4-1 step 2
 		d[a]*=abs(sin(rotpos))
		d[a+1]*=abs(cos(rotpos))
		rotpos+=0.00003
	next
	rotpos = fmod(rotpos,2*M_PI)
end sub

' "echo"
dim shared as HDSP echdsp=0	' DSP handle
#define ECHBUFLEN 1200	' buffer length
dim shared as float echbuf(ECHBUFLEN-1,1)	' buffer
dim shared as integer echpos	' cur.pos
sub Echo(byval handle as HDSP, byval channel as DWORD , byval buffer as any ptr, byval length as DWORD, byval user as any ptr)
	dim as single ptr d=buffer
	dim as DWORD a

	for a=0 to length/4-1 step 2 
		dim as single l=d[a]+(echbuf(echpos,1)/2)
		dim as float r=d[a+1]+(echbuf(echpos,0)/2)
#if 1 ' 0=echo, 1=basic "bathroom" reverb
		echbuf(echpos,0)=l
d[a]=l
		echbuf(echpos,1)=r
d[a+1]=r
#else
		echbuf(echpos,0)=d[a]
		echbuf(echpos,1)=d[a+1]
		d[a]=l
		d[a+1]=r
#endif
		echpos +=1
		if (echpos = ECHBUFLEN) then echpos=0
	next
end sub

' "flanger"
dim shared as HDSP fladsp=0	' DSP handle
#define FLABUFLEN 350	' buffer length
dim shared as float flabuf(FLABUFLEN,1)	' buffer
dim shared as integer flapos	' cur.pos
dim shared as float flas,flasinc	' sweep pos/increment
sub Flange(byval handle as HDSP, byval channel as DWORD, byval buffer as any ptr, byval length as DWORD, byval user as any ptr)
	dim as single ptr d=buffer
	dim as DWORD a

	for a=0 to length/4-1 step 2
		dim as integer p1=(flapos+int(flas)) mod FLABUFLEN
		dim as integer p2=(p1+1) mod FLABUFLEN
		dim as single f=flas-int(flas)
		dim as single s

		s=(d[a]+((flabuf(p1,0)*(1-f))+(flabuf(p2,0)*f)))*0.7
		flabuf(flapos,0)=d[a]
		d[a]=s

		s=(d[a+1]+((flabuf(p1,1)*(1-f))+(flabuf(p2,1)*f)))*0.7
		flabuf(flapos,1)=d[a+1]
		d[a+1]=s

		flapos +=1
		if (flapos = FLABUFLEN) then flapos=0
		flas+=flasinc
		if (flas<0 or flas>FLABUFLEN-1) then
			flasinc=-flasinc
			flas+=flasinc
		end if
	next
end sub


#define MESS(id,m,w,l) SendDlgItemMessage(win,id,m,w,cast(lparam,l))

function dialogproc(byval h as HWND, byval m as uinteger, byval w as WPARAM, byval l as LPARAM) as BOOL
	select case m
		case WM_COMMAND
select case LOWORD(w)
				case IDCANCEL
					DestroyWindow(h)
				case 10:
						dim as BASS_CHANNELINFO info
						dim as zstring * MAX_PATH filename
						ofn.lpstrFilter=@!"playable files\0*.mo3;*.xm;*.mod;*.s3m;*.it;*.mtm;*.umx;*.mp3;*.mp2;*.mp1;*.ogg;*.wav;*.aif\0All files\0*.*\0\0"
						ofn.lpstrFile=@filename
						if (GetOpenFileName(@ofn)) then
							' free both MOD and stream, it must be one of them! :)
							BASS_MusicFree(chan)
							BASS_StreamFree(chan)

chan=BASS_StreamCreateFile(FALSE,@filename,0,0,BASS_SAMPLE_LOOP or floatable)
if chan = 0 then
chan=BASS_MusicLoad(FALSE,@filename,0,0,BASS_SAMPLE_LOOP or BASS_MUSIC_RAMPS or floatable,1)
if chan = 0 then
							' whatever it is, it ain't playable
								MESS(10,WM_SETTEXT,0,"click here to open a file...")
								Errormess("Can't play the file")
exit select
							end if
end if
							
							BASS_ChannelGetInfo(chan,@info)
							if (info.chans <> 2) then
 ' only stereo is allowed
								MESS(10,WM_SETTEXT,0,"click here to open a file...")
								BASS_MusicFree(chan)
								BASS_StreamFree(chan)
								ErrorMess("only stereo sources are supported")
								exit select
							end if
							MESS(10,WM_SETTEXT,0,@filename)
							' setup DSPs on new channel and play it
							SendMessage(win,WM_COMMAND,11,0)
							SendMessage(win,WM_COMMAND,12,0)
							SendMessage(win,WM_COMMAND,13,0)
							BASS_ChannelPlay(chan,FALSE)
						end if
				case 11 ' toggle "rotate"
					if (MESS(11,BM_GETCHECK,0,0)) then
						rotpos=0.7853981f
						rotdsp=BASS_ChannelSetDSP(chan,@Rotate,0,2)
					 else
						BASS_ChannelRemoveDSP(chan,rotdsp)
end if
									case 12 ' toggle "echo"
					if (MESS(12,BM_GETCHECK,0,0)) then
erase(echbuf)
						echpos=0
						echdsp=BASS_ChannelSetDSP(chan,@Echo,0,1)
					else
						BASS_ChannelRemoveDSP(chan,echdsp)
					end if
				case 13 ' toggle "flanger"
					if (MESS(13,BM_GETCHECK,0,0)) then
erase(flabuf)
						flapos=0
					    flas=FLABUFLEN/2
					    flasinc=0.002f
						fladsp=BASS_ChannelSetDSP(chan,@Flange,0,0)
					else
						BASS_ChannelRemoveDSP(chan,fladsp)
end if
			end select
					case WM_INITDIALOG
			win=h
			clear(ofn,0,sizeof(ofn))
			ofn.lStructSize=sizeof(ofn)
			ofn.hwndOwner=h
			ofn.nMaxFile=MAX_PATH
			ofn.Flags=OFN_HIDEREADONLY or OFN_EXPLORER
			' enable floating-point DSP
			BASS_SetConfig(BASS_CONFIG_FLOATDSP,TRUE)
			' initialize - default device
			if (BASS_Init(-1,44100,0,win,NULL)) = 0 then
				ErrorMess("Can't initialize device")
				DestroyWindow(win)
exit select
			end if
			' check for floating-point capability
			floatable=BASS_StreamCreate(44100,2,BASS_SAMPLE_FLOAT,NULL,0)
			if (floatable) then ' woohoo!
				BASS_StreamFree(floatable)
				floatable=BASS_SAMPLE_FLOAT
			end if
		case WM_DESTROY:
			BASS_Free()
		case else
return FALSE
	end select
	return TRUE
end function

	' check the correct BASS was loaded
	if (HIWORD(BASS_GetVersion()) <> BASSVERSION) then
		MessageBox(0,"An incorrect version of BASS.DLL was loaded",0,MB_ICONERROR)
		end
end if
dim as HANDLE hModule = GetModuleHandle(NULL)
	end DialogBox(hModule,cast(zstring ptr,1000),0,@dialogproc)
