#ifndef __MMNCPU_BI__
#define __MMNCPU_BI__

'  #############
' # mmncpu.bi #
'#############
' Copyright 2005-2013 by D.J.Peters (Joshy)
' d.j.peters@web.de

#include once "fbstypes.bi"
#inclib "fbscpu"


#define _AAP as any ptr
#define _AAPP as any ptr ptr

declare function IsFPU              () as FBSBOOLEAN
declare function IsTSC              () as FBSBOOLEAN
declare function IsCMOV             () as FBSBOOLEAN
declare function IsMMX              () as FBSBOOLEAN
declare function IsMMX2             () as FBSBOOLEAN
declare function IsSSE              () as FBSBOOLEAN
declare function IsSSE2             () as FBSBOOLEAN
declare function IsNOW3D            () as FBSBOOLEAN
declare function IsNOW3D2           () as FBSBOOLEAN
declare function Mhz                () as integer
declare function CPUCounter         () as longint

declare sub      Zero               (byval d _AAP,byval n as integer)
declare sub      ZeroBuffer         (byval s _AAP,byval p _AAPP,byval e _AAP,byval n as integer)
declare sub      Copy               (byval d _AAP,byval s _AAP ,byval n as integer)
declare sub      Mix16              (byval d _AAP,byval a _AAP ,byval b _AAP,byval n as integer)
declare sub      Scale16            (byval d _AAP,byval s _AAP ,byval v  as single,byval n as integer)
declare sub      Pan16              (byval d _AAP,byval s _AAP ,byval l  as single,byval r as single,byval n as integer)
declare sub      CopyRight16        (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval n as integer)
declare sub      CopyRight32        (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval n as integer)
declare sub      MoveRight16        (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval n as integer)
declare sub      MoveRight32        (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval n as integer)
declare sub      CopySliceRight16   (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      CopySliceRight32   (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      MoveSliceRight16   (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      MoveSliceRight32   (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      CopySliceLeft16    (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      CopySliceLeft32    (byval d _AAP,byval s _AAP ,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      MoveSliceLeft16    (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)
declare sub      MoveSliceLeft32    (byval s _AAP,byval p _AAPP,byval e _AAP ,byval l _AAPP,byval v as single,byval n as integer)

#ifndef NOMP3
declare sub      CopyMP3Frame       (byval s _AAP,byval p _AAPP,byval e _AAP ,byval f _AAP ,byval n as integer)
declare sub      CopySliceMP3Frame32(byval s _AAP,byval p _AAPP,byval e _AAP ,byval f _AAP ,byval v as single,byval n as integer)
declare sub      CopySliceMP3Frame16(byval s _AAP,byval p _AAPP,byval e _AAP ,byval f _AAP ,byval v as single,byval n as integer)
declare sub      ScaleMP3Frame_22_16(byval d _AAP,byval a _AAP ,byval b _AAP ,byval n as integer)
declare sub      ScaleMP3Frame_21_16(byval d _AAP,byval a _AAP ,byval b _AAP ,byval n as integer)
declare sub      ScaleMP3Frame_12_16(byval d _AAP,byval s _AAP ,byval n as integer)
declare sub      ScaleMP3Frame_11_16(byval d _AAP,byval s _AAP ,byval n as integer)
#endif

#endif ' __MMNCPU_BI__
